Index: drivers/filesystems/btrfs/fileinfo.c
===================================================================
--- drivers/filesystems/btrfs/fileinfo.c	(révision 75772)
+++ drivers/filesystems/btrfs/fileinfo.c	(copie de travail)
@@ -1,17 +1,17 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
@@ -24,9 +24,7 @@
 #endif
 #endif
 
-static NTSTATUS get_inode_dir_path(device_extension* Vcb, root* subvol, UINT64 inode, PUNICODE_STRING us, PIRP Irp);
-
-static NTSTATUS STDCALL set_basic_information(device_extension* Vcb, PIRP Irp, PFILE_OBJECT FileObject) {
+static NTSTATUS set_basic_information(device_extension* Vcb, PIRP Irp, PFILE_OBJECT FileObject) {
     FILE_BASIC_INFORMATION* fbi = Irp->AssociatedIrp.SystemBuffer;
     fcb* fcb = FileObject->FsContext;
     ccb* ccb = FileObject->FsContext2;
@@ -34,7 +32,7 @@
     ULONG defda, filter = 0;
     BOOL inode_item_changed = FALSE;
     NTSTATUS Status;
-    
+
     if (fcb->ads) {
         if (fileref && fileref->parent)
             fcb = fileref->parent->fcb;
@@ -43,23 +41,35 @@
             return STATUS_INTERNAL_ERROR;
         }
     }
-    
+
+    if (!ccb) {
+        ERR("ccb was NULL\n");
+        return STATUS_INVALID_PARAMETER;
+    }
+
     TRACE("file = %S, attributes = %x\n", file_desc(FileObject), fbi->FileAttributes);
-    
+
     ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
-    
+
     if (fbi->FileAttributes & FILE_ATTRIBUTE_DIRECTORY && fcb->type != BTRFS_TYPE_DIRECTORY) {
         WARN("attempted to set FILE_ATTRIBUTE_DIRECTORY on non-directory\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
-    if (fcb->inode == SUBVOL_ROOT_INODE && fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY &&
+
+    if (fcb->inode == SUBVOL_ROOT_INODE && is_subvol_readonly(fcb->subvol, Irp) &&
         (fbi->FileAttributes == 0 || fbi->FileAttributes & FILE_ATTRIBUTE_READONLY)) {
         Status = STATUS_ACCESS_DENIED;
         goto end;
     }
-    
+
+    // don't allow readonly subvol to be made r/w if send operation running on it
+    if (fcb->inode == SUBVOL_ROOT_INODE && fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY &&
+        fcb->subvol->send_ops > 0) {
+        Status = STATUS_DEVICE_NOT_READY;
+        goto end;
+    }
+
     if (fbi->CreationTime.QuadPart == -1)
         ccb->user_set_creation_time = TRUE;
     else if (fbi->CreationTime.QuadPart != 0) {
@@ -66,10 +76,10 @@
         win_time_to_unix(fbi->CreationTime, &fcb->inode_item.otime);
         inode_item_changed = TRUE;
         filter |= FILE_NOTIFY_CHANGE_CREATION;
-        
+
         ccb->user_set_creation_time = TRUE;
     }
-    
+
     if (fbi->LastAccessTime.QuadPart == -1)
         ccb->user_set_access_time = TRUE;
     else if (fbi->LastAccessTime.QuadPart != 0) {
@@ -76,10 +86,10 @@
         win_time_to_unix(fbi->LastAccessTime, &fcb->inode_item.st_atime);
         inode_item_changed = TRUE;
         filter |= FILE_NOTIFY_CHANGE_LAST_ACCESS;
-        
+
         ccb->user_set_access_time = TRUE;
     }
-    
+
     if (fbi->LastWriteTime.QuadPart == -1)
         ccb->user_set_write_time = TRUE;
     else if (fbi->LastWriteTime.QuadPart != 0) {
@@ -86,10 +96,10 @@
         win_time_to_unix(fbi->LastWriteTime, &fcb->inode_item.st_mtime);
         inode_item_changed = TRUE;
         filter |= FILE_NOTIFY_CHANGE_LAST_WRITE;
-        
+
         ccb->user_set_write_time = TRUE;
     }
-    
+
     if (fbi->ChangeTime.QuadPart == -1)
         ccb->user_set_change_time = TRUE;
     else if (fbi->ChangeTime.QuadPart != 0) {
@@ -96,41 +106,46 @@
         win_time_to_unix(fbi->ChangeTime, &fcb->inode_item.st_ctime);
         inode_item_changed = TRUE;
         // no filter for this
-        
+
         ccb->user_set_change_time = TRUE;
     }
-    
+
     // FileAttributes == 0 means don't set - undocumented, but seen in fastfat
     if (fbi->FileAttributes != 0) {
         LARGE_INTEGER time;
         BTRFS_TIME now;
-        
-        defda = get_file_attributes(Vcb, &fcb->inode_item, fcb->subvol, fcb->inode, fcb->type, fileref->filepart.Length > 0 && fileref->filepart.Buffer[0] == '.', TRUE, Irp);
-        
+
+        fbi->FileAttributes &= ~FILE_ATTRIBUTE_NORMAL;
+
+        defda = get_file_attributes(Vcb, fcb->subvol, fcb->inode, fcb->type, fileref && fileref->dc && fileref->dc->name.Length >= sizeof(WCHAR) && fileref->dc->name.Buffer[0] == '.',
+                                    TRUE, Irp);
+
         if (fcb->type == BTRFS_TYPE_DIRECTORY)
             fbi->FileAttributes |= FILE_ATTRIBUTE_DIRECTORY;
         else if (fcb->type == BTRFS_TYPE_SYMLINK)
             fbi->FileAttributes |= FILE_ATTRIBUTE_REPARSE_POINT;
-                
+
         fcb->atts_changed = TRUE;
-        
+
         if (fcb->atts & FILE_ATTRIBUTE_REPARSE_POINT)
             fbi->FileAttributes |= FILE_ATTRIBUTE_REPARSE_POINT;
-        
+
         if (defda == fbi->FileAttributes)
             fcb->atts_deleted = TRUE;
-        
+        else if (fcb->inode == SUBVOL_ROOT_INODE && (defda | FILE_ATTRIBUTE_READONLY) == (fbi->FileAttributes | FILE_ATTRIBUTE_READONLY))
+            fcb->atts_deleted = TRUE;
+
         fcb->atts = fbi->FileAttributes;
-        
+
         KeQuerySystemTime(&time);
         win_time_to_unix(time, &now);
-        
+
         if (!ccb->user_set_change_time)
             fcb->inode_item.st_ctime = now;
-        
+
         fcb->subvol->root_item.ctransid = Vcb->superblock.generation;
         fcb->subvol->root_item.ctime = now;
-        
+
         if (fcb->inode == SUBVOL_ROOT_INODE) {
             if (fbi->FileAttributes & FILE_ATTRIBUTE_READONLY)
                 fcb->subvol->root_item.flags |= BTRFS_SUBVOL_READONLY;
@@ -137,9 +152,9 @@
             else
                 fcb->subvol->root_item.flags &= ~BTRFS_SUBVOL_READONLY;
         }
-        
+
         inode_item_changed = TRUE;
-        
+
         filter |= FILE_NOTIFY_CHANGE_ATTRIBUTES;
     }
 
@@ -147,22 +162,22 @@
         fcb->inode_item.transid = Vcb->superblock.generation;
         fcb->inode_item.sequence++;
         fcb->inode_item_changed = TRUE;
-        
+
         mark_fcb_dirty(fcb);
     }
-    
+
     if (filter != 0)
-        send_notification_fcb(fileref, filter, FILE_ACTION_MODIFIED);
+        send_notification_fcb(fileref, filter, FILE_ACTION_MODIFIED, NULL);
 
     Status = STATUS_SUCCESS;
 
 end:
     ExReleaseResourceLite(fcb->Header.Resource);
-    
+
     return Status;
 }
 
-static NTSTATUS STDCALL set_disposition_information(device_extension* Vcb, PIRP Irp, PFILE_OBJECT FileObject) {
+static NTSTATUS set_disposition_information(device_extension* Vcb, PIRP Irp, PFILE_OBJECT FileObject) {
     FILE_DISPOSITION_INFORMATION* fdi = Irp->AssociatedIrp.SystemBuffer;
     fcb* fcb = FileObject->FsContext;
     ccb* ccb = FileObject->FsContext2;
@@ -169,16 +184,16 @@
     file_ref* fileref = ccb ? ccb->fileref : NULL;
     ULONG atts;
     NTSTATUS Status;
-    
+
     if (!fileref)
         return STATUS_INVALID_PARAMETER;
-    
+
     ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
-    
+
     ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
-    
+
     TRACE("changing delete_on_close to %s for %S (fcb %p)\n", fdi->DeleteFile ? "TRUE" : "FALSE", file_desc(FileObject), fcb);
-    
+
     if (fcb->ads) {
         if (fileref->parent)
             atts = fileref->parent->fcb->atts;
@@ -189,58 +204,66 @@
         }
     } else
         atts = fcb->atts;
-    
+
     TRACE("atts = %x\n", atts);
-    
+
     if (atts & FILE_ATTRIBUTE_READONLY) {
+        TRACE("not allowing readonly file to be deleted\n");
         Status = STATUS_CANNOT_DELETE;
         goto end;
     }
-    
+
     // FIXME - can we skip this bit for subvols?
-    if (fcb->type == BTRFS_TYPE_DIRECTORY && fcb->inode_item.st_size > 0) {
+    if (fcb->type == BTRFS_TYPE_DIRECTORY && fcb->inode_item.st_size > 0 && (!fileref || fileref->fcb != Vcb->dummy_fcb)) {
+        TRACE("directory not empty\n");
         Status = STATUS_DIRECTORY_NOT_EMPTY;
         goto end;
     }
-    
+
     if (!MmFlushImageSection(&fcb->nonpaged->segment_object, MmFlushForDelete)) {
-        WARN("trying to delete file which is being mapped as an image\n");
+        TRACE("trying to delete file which is being mapped as an image\n");
         Status = STATUS_CANNOT_DELETE;
         goto end;
     }
-    
+
     ccb->fileref->delete_on_close = fdi->DeleteFile;
-    
+
     FileObject->DeletePending = fdi->DeleteFile;
-    
+
     Status = STATUS_SUCCESS;
-    
+
 end:
     ExReleaseResourceLite(fcb->Header.Resource);
-    
+
     ExReleaseResourceLite(&Vcb->fcb_lock);
 
+    // send notification that directory is about to be deleted
+    if (NT_SUCCESS(Status) && fdi->DeleteFile && fcb->type == BTRFS_TYPE_DIRECTORY) {
+        FsRtlNotifyFullChangeDirectory(Vcb->NotifySync, &Vcb->DirNotifyList, FileObject->FsContext,
+                                       NULL, FALSE, FALSE, 0, NULL, NULL, NULL);
+    }
+
     return Status;
 }
 
 BOOL has_open_children(file_ref* fileref) {
     LIST_ENTRY* le = fileref->children.Flink;
-    
+
     if (IsListEmpty(&fileref->children))
         return FALSE;
-        
+
     while (le != &fileref->children) {
         file_ref* c = CONTAINING_RECORD(le, file_ref, list_entry);
-        
+
         if (c->open_count > 0)
             return TRUE;
-        
+
         if (has_open_children(c))
             return TRUE;
 
         le = le->Flink;
     }
-    
+
     return FALSE;
 }
 
@@ -248,15 +271,15 @@
     device_extension* Vcb = oldfcb->Vcb;
     fcb* fcb;
     LIST_ENTRY* le;
-    
+
     // FIXME - we can skip a lot of this if the inode is about to be deleted
-    
-    fcb = create_fcb(PagedPool); // FIXME - what if we duplicate the paging file?
+
+    fcb = create_fcb(Vcb, PagedPool); // FIXME - what if we duplicate the paging file?
     if (!fcb) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     fcb->Vcb = Vcb;
 
     fcb->Header.IsFastIoPossible = fast_io_possible(fcb);
@@ -263,112 +286,102 @@
     fcb->Header.AllocationSize = oldfcb->Header.AllocationSize;
     fcb->Header.FileSize = oldfcb->Header.FileSize;
     fcb->Header.ValidDataLength = oldfcb->Header.ValidDataLength;
-    
+
     fcb->type = oldfcb->type;
-    
+
     if (oldfcb->ads) {
         fcb->ads = TRUE;
         fcb->adshash = oldfcb->adshash;
         fcb->adsmaxlen = oldfcb->adsmaxlen;
-        
+
         if (oldfcb->adsxattr.Buffer && oldfcb->adsxattr.Length > 0) {
             fcb->adsxattr.Length = oldfcb->adsxattr.Length;
             fcb->adsxattr.MaximumLength = fcb->adsxattr.Length + 1;
             fcb->adsxattr.Buffer = ExAllocatePoolWithTag(PagedPool, fcb->adsxattr.MaximumLength, ALLOC_TAG);
-            
+
             if (!fcb->adsxattr.Buffer) {
                 ERR("out of memory\n");
-                free_fcb(fcb);
+                free_fcb(Vcb, fcb);
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
+
             RtlCopyMemory(fcb->adsxattr.Buffer, oldfcb->adsxattr.Buffer, fcb->adsxattr.Length);
             fcb->adsxattr.Buffer[fcb->adsxattr.Length] = 0;
         }
-        
+
         if (oldfcb->adsdata.Buffer && oldfcb->adsdata.Length > 0) {
             fcb->adsdata.Length = fcb->adsdata.MaximumLength = oldfcb->adsdata.Length;
             fcb->adsdata.Buffer = ExAllocatePoolWithTag(PagedPool, fcb->adsdata.MaximumLength, ALLOC_TAG);
-            
+
             if (!fcb->adsdata.Buffer) {
                 ERR("out of memory\n");
-                free_fcb(fcb);
+                free_fcb(Vcb, fcb);
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
+
             RtlCopyMemory(fcb->adsdata.Buffer, oldfcb->adsdata.Buffer, fcb->adsdata.Length);
         }
-        
+
         goto end;
     }
-    
+
     RtlCopyMemory(&fcb->inode_item, &oldfcb->inode_item, sizeof(INODE_ITEM));
     fcb->inode_item_changed = TRUE;
-    
+
     if (oldfcb->sd && RtlLengthSecurityDescriptor(oldfcb->sd) > 0) {
         fcb->sd = ExAllocatePoolWithTag(PagedPool, RtlLengthSecurityDescriptor(oldfcb->sd), ALLOC_TAG);
         if (!fcb->sd) {
             ERR("out of memory\n");
-            free_fcb(fcb);
+            free_fcb(Vcb, fcb);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         RtlCopyMemory(fcb->sd, oldfcb->sd, RtlLengthSecurityDescriptor(oldfcb->sd));
     }
-    
+
     fcb->atts = oldfcb->atts;
-    
+
     le = oldfcb->extents.Flink;
     while (le != &oldfcb->extents) {
         extent* ext = CONTAINING_RECORD(le, extent, list_entry);
-        
+
         if (!ext->ignore) {
-            extent* ext2 = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
-            
+            extent* ext2 = ExAllocatePoolWithTag(PagedPool, offsetof(extent, extent_data) + ext->datalen, ALLOC_TAG);
+
             if (!ext2) {
                 ERR("out of memory\n");
-                free_fcb(fcb);
+                free_fcb(Vcb, fcb);
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
+
             ext2->offset = ext->offset;
             ext2->datalen = ext->datalen;
-            
-            if (ext2->datalen > 0) {
-                ext2->data = ExAllocatePoolWithTag(PagedPool, ext2->datalen, ALLOC_TAG);
-                
-                if (!ext2->data) {
-                    ERR("out of memory\n");
-                    free_fcb(fcb);
-                    return STATUS_INSUFFICIENT_RESOURCES;
-                }
-                
-                RtlCopyMemory(ext2->data, ext->data, ext2->datalen);
-            } else
-                ext2->data = NULL;
-            
+
+            if (ext2->datalen > 0)
+                RtlCopyMemory(&ext2->extent_data, &ext->extent_data, ext2->datalen);
+
             ext2->unique = FALSE;
             ext2->ignore = FALSE;
             ext2->inserted = TRUE;
-            
+
             if (ext->csum) {
                 ULONG len;
-                EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->data->data;
-                
-                if (ext->data->compression == BTRFS_COMPRESSION_NONE)
-                    len = ed2->num_bytes;
+                EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->extent_data.data;
+
+                if (ext->extent_data.compression == BTRFS_COMPRESSION_NONE)
+                    len = (ULONG)ed2->num_bytes;
                 else
-                    len = ed2->size;
-                
+                    len = (ULONG)ed2->size;
+
                 len = len * sizeof(UINT32) / Vcb->superblock.sector_size;
-                
+
                 ext2->csum = ExAllocatePoolWithTag(PagedPool, len, ALLOC_TAG);
                 if (!ext2->csum) {
                     ERR("out of memory\n");
-                    free_fcb(fcb);
+                    free_fcb(Vcb, fcb);
                     return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
+
                 RtlCopyMemory(ext2->csum, ext->csum, len);
             } else
                 ext2->csum = NULL;
@@ -375,86 +388,112 @@
 
             InsertTailList(&fcb->extents, &ext2->list_entry);
         }
-        
+
         le = le->Flink;
     }
-    
+
     le = oldfcb->hardlinks.Flink;
     while (le != &oldfcb->hardlinks) {
         hardlink *hl = CONTAINING_RECORD(le, hardlink, list_entry), *hl2;
-        
+
         hl2 = ExAllocatePoolWithTag(PagedPool, sizeof(hardlink), ALLOC_TAG);
-        
+
         if (!hl2) {
             ERR("out of memory\n");
-            free_fcb(fcb);
+            free_fcb(Vcb, fcb);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         hl2->parent = hl->parent;
         hl2->index = hl->index;
-        
+
         hl2->name.Length = hl2->name.MaximumLength = hl->name.Length;
         hl2->name.Buffer = ExAllocatePoolWithTag(PagedPool, hl2->name.MaximumLength, ALLOC_TAG);
-        
+
         if (!hl2->name.Buffer) {
             ERR("out of memory\n");
             ExFreePool(hl2);
-            free_fcb(fcb);
+            free_fcb(Vcb, fcb);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         RtlCopyMemory(hl2->name.Buffer, hl->name.Buffer, hl->name.Length);
-        
+
         hl2->utf8.Length = hl2->utf8.MaximumLength = hl->utf8.Length;
         hl2->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, hl2->utf8.MaximumLength, ALLOC_TAG);
-        
+
         if (!hl2->utf8.Buffer) {
             ERR("out of memory\n");
             ExFreePool(hl2->name.Buffer);
             ExFreePool(hl2);
-            free_fcb(fcb);
+            free_fcb(Vcb, fcb);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         RtlCopyMemory(hl2->utf8.Buffer, hl->utf8.Buffer, hl->utf8.Length);
-        
+
         InsertTailList(&fcb->hardlinks, &hl2->list_entry);
-        
+
         le = le->Flink;
     }
-    
-    fcb->last_dir_index = oldfcb->last_dir_index;
-    
+
     if (oldfcb->reparse_xattr.Buffer && oldfcb->reparse_xattr.Length > 0) {
         fcb->reparse_xattr.Length = fcb->reparse_xattr.MaximumLength = oldfcb->reparse_xattr.Length;
-        
+
         fcb->reparse_xattr.Buffer = ExAllocatePoolWithTag(PagedPool, fcb->reparse_xattr.MaximumLength, ALLOC_TAG);
         if (!fcb->reparse_xattr.Buffer) {
             ERR("out of memory\n");
-            free_fcb(fcb);
+            free_fcb(Vcb, fcb);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         RtlCopyMemory(fcb->reparse_xattr.Buffer, oldfcb->reparse_xattr.Buffer, fcb->reparse_xattr.Length);
     }
-    
+
     if (oldfcb->ea_xattr.Buffer && oldfcb->ea_xattr.Length > 0) {
         fcb->ea_xattr.Length = fcb->ea_xattr.MaximumLength = oldfcb->ea_xattr.Length;
-        
+
         fcb->ea_xattr.Buffer = ExAllocatePoolWithTag(PagedPool, fcb->ea_xattr.MaximumLength, ALLOC_TAG);
         if (!fcb->ea_xattr.Buffer) {
             ERR("out of memory\n");
-            free_fcb(fcb);
+            free_fcb(Vcb, fcb);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         RtlCopyMemory(fcb->ea_xattr.Buffer, oldfcb->ea_xattr.Buffer, fcb->ea_xattr.Length);
     }
 
+    fcb->prop_compression = oldfcb->prop_compression;
+
+    le = oldfcb->xattrs.Flink;
+    while (le != &oldfcb->xattrs) {
+        xattr* xa = CONTAINING_RECORD(le, xattr, list_entry);
+
+        if (xa->valuelen > 0) {
+            xattr* xa2;
+
+            xa2 = ExAllocatePoolWithTag(PagedPool, offsetof(xattr, data[0]) + xa->namelen + xa->valuelen, ALLOC_TAG);
+
+            if (!xa2) {
+                ERR("out of memory\n");
+                free_fcb(Vcb, fcb);
+                return STATUS_INSUFFICIENT_RESOURCES;
+            }
+
+            xa2->namelen = xa->namelen;
+            xa2->valuelen = xa->valuelen;
+            xa2->dirty = xa->dirty;
+            memcpy(xa2->data, xa->data, xa->namelen + xa->valuelen);
+
+            InsertTailList(&fcb->xattrs, &xa2->list_entry);
+        }
+
+        le = le->Flink;
+    }
+
 end:
     *pfcb = fcb;
-    
+
     return STATUS_SUCCESS;
 }
 
